#include <math.h>
unsigned char dds[256];
unsigned char osz[500];
unsigned int ph, n, i, j;

ISR (TIMER0_OVF_vect)
{
  PORTD |= 4;
  ph += 256;
  OCR0A = dds[ph >> 8];
  if (i < 500) {
    osz[i] = ADCH;
    i++;
  }
  PORTD &= ~4;
}

int main(void)
{
  unsigned int  n;
  Serial.begin(1000000);
  for (n = 0; n < 256; n++) dds[n] = 127 + 127 * sin(PI * n 
      / 128.0);
  DDRD = 254;
  TCCR0A = 0xA3;  //Timer0 Fast PWM an PD5/6
  TCCR0B = 0x01;  //16 MHz
  TIMSK0 = 0x01;  //Timer0 Overflow Interrupt
  OCR0A = 128;
  OCR0B = 128;
  ADMUX = 0x60;   //ADC Ref = VCC, Left adjusted;
  ADCSRB = 4;     //4  'Timer0 Start    0= free running
  ADCSRA = 0xE4;  //ADC Enable, Start, Auto Trigger, 1MHz;
  sei();
  while (true) {
    i = 0;
    for (n = 1; n < 65000; n++) {
      for (j = 1; j < 20; j++){ asm ("nop");}
    }
    for (n = 0; n < 500; n++) {
      Serial.println(osz[n]);  
    }
  }
}
